using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Web.Script.Services;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Collections.Generic;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
[ScriptService]
[GenerateScriptType(typeof(Employee))]
public class EmployeeService : System.Web.Services.WebService
{
    private string strConn = "";

    public EmployeeService()
    {
        strConn = ConfigurationManager.ConnectionStrings["connstr"].ConnectionString;
    }


    [WebMethod]
    public Employee[] GetEmployees()
    {
        SqlConnection cnn = new SqlConnection(strConn);
        cnn.Open();
        SqlCommand cmd = new SqlCommand();
        cmd.Connection = cnn;
        cmd.CommandText = "select employeeid,firstname,lastname from employees";
        SqlDataReader reader = cmd.ExecuteReader();
        List<Employee> list = new List<Employee>();
        while (reader.Read())
        {
            Employee emp = new Employee();
            emp.EmployeeID = reader.GetInt32(0);
            emp.FirstName = reader.GetString(1);
            emp.LastName = reader.GetString(2);
            list.Add(emp);
        }
        reader.Close();
        cnn.Close();
        return list.ToArray();
    }

    [WebMethod]
    public Employee GetEmployee(int pEmployeeId)
    {
        SqlConnection cnn = new SqlConnection(strConn);
        cnn.Open();
        SqlCommand cmd = new SqlCommand();
        cmd.Connection = cnn;
        cmd.CommandText = "select employeeid,firstname,lastname from employees where employeeid=@id";
        SqlParameter id = new SqlParameter("@id", pEmployeeId);
        cmd.Parameters.Add(id);
        SqlDataReader reader = cmd.ExecuteReader();
        Employee emp = new Employee();
        while (reader.Read())
        {
            emp.EmployeeID = reader.GetInt32(0);
            emp.FirstName = reader.GetString(1);
            emp.LastName = reader.GetString(2);
        }
        reader.Close();
        cnn.Close();
        return emp;
    }

    [WebMethod]
    public int Insert(string pFirstName, string pLastName)
    {
        SqlConnection cnn = new SqlConnection(strConn);
        cnn.Open();
        SqlCommand cmd = new SqlCommand();
        cmd.Connection = cnn;
        cmd.CommandText = "insert into employees(firstname,lastname) values (@fname,@lname)";
        SqlParameter fname = new SqlParameter("@fname", pFirstName);
        SqlParameter lname = new SqlParameter("@lname", pLastName);
        cmd.Parameters.Add(fname);
        cmd.Parameters.Add(lname);
        int i = cmd.ExecuteNonQuery();
        cnn.Close();
        return i;
    }

    [WebMethod]
    public int Update(int pEmployeeId,string pFirstName, string pLastName)
    {
        SqlConnection cnn = new SqlConnection(strConn);
        cnn.Open();
        SqlCommand cmd = new SqlCommand();
        cmd.Connection = cnn;
        cmd.CommandText = "update employees set firstname=@fname,lastname=@lname where employeeid=@id";
        SqlParameter fname = new SqlParameter("@fname", pFirstName);
        SqlParameter lname = new SqlParameter("@lname", pLastName);
        SqlParameter id = new SqlParameter("@id", pEmployeeId);
        cmd.Parameters.Add(fname);
        cmd.Parameters.Add(lname);
        cmd.Parameters.Add(id);
        int i = cmd.ExecuteNonQuery();
        cnn.Close();


        return i;
    }

    [WebMethod]
    public int Delete(int pEmployeeId)
    {
        SqlConnection cnn = new SqlConnection(strConn);
        cnn.Open();
        SqlCommand cmd = new SqlCommand();
        cmd.Connection = cnn;
        cmd.CommandText = "delete from employees where employeeid=@id";
        SqlParameter id = new SqlParameter("@id", pEmployeeId);
        cmd.Parameters.Add(id);
        int i = cmd.ExecuteNonQuery();
        cnn.Close();
        return i;
    }

}

